<?php

/***************************************************************************
*                            Dolphin Smart Community Builder
*                              -------------------
*     begin                : Mon Mar 23 2006
*     copyright            : (C) 2007 BoonEx Group
*     website              : http://www.boonex.com
* This file is part of Dolphin - Smart Community Builder
*
* Dolphin is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the
* License, or  any later version.
*
* Dolphin is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
* without even the implied warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with Dolphin,
* see license.txt file; if not, write to marketing@boonex.com
***************************************************************************/
define("ADMIN_ROLE","3");
define("LOGIN_SUCCESS",0);
define("LOGIN_PASSWD_ERROR",1);
define("LOGIN_NICK_EXIST",2);
define("LOGIN_ERROR",3);
define("LOGIN_ERROR_NOUSERID",4);
define("LOGIN_SUCCESS_ADMIN",5);
define("LOGIN_NOT_ALLOW_GUEST",6);
define("LOGIN_USER_BANED",7);

bx_import('BxDolModule');

class TmChatModule extends BxDolModule
{
    /**
	 * Class constructor ;
	 */
	function TmChatModule(&$aModule)
    {
        parent::BxDolModule($aModule);
    }

    /**
     * Function will generate the chat's page;
     */
    function actionHome()
    {
        $this->_oTemplate->pageStart();
        $server = getParam('fc_server');
        $client = getParam('fc_client');
        $lang = getParam('fc_client_lang');
        $skin = getParam('fc_client_skin');
		if ($server != "2")
		{
			$client_name = ($client != "0") ? (($client == "1") ? 'htmlchat/123flashchat.html' : 'avatarchat.swf') : '123flashchat.swf';
			$chaturl = getParam('fc_client_loc') . $client_name . "?init_host=" . getParam('fc_server_host') . "&init_port=" . getParam('fc_server_port');
			$chaturl .= ($server == "1") ? ("&init_group=" . getParam('fc_group')) : "";
		}
		else
		{
			$chaturl = "http://free.123flashchat.com/js.php?room=" . getParam('fc_room') . "&skin="  . $skin . "&lang="  . $lang;
		}
		if ($room = $_GET['room'])
		{
			$chaturl .= "&init_room=" . $room;
		}
		if ($user = getProfileInfo())
		{
			if(!empty( $user['NickName'] ))
			{
				$chaturl .= "&init_user=" . rawurlencode($user['NickName']) . "&init_password=" . rawurlencode($user['Password']);
			}
		}
        $aVars = array (
            'bx_if:default_chat' => array(
                'condition' => ($server != "2" && $client != "1") ? true : false,
                'content' => array(),
            ),
            'bx_if:html_chat' => array(
                'condition' => ($server != "2" && $client == "1") ? true : false,
                'content' => array(),
            ),
            'bx_if:free_chat' => array(
                'condition' => ($server == "2") ? true : false,
                'content' => array(),
            ),
            'fc_client_loc' => getParam('fc_client_loc') . "123flashchat.js",
            'url' => $chaturl,
            'width' => getParam('fc_client_width'),
            'height' => getParam('fc_client_height'),
        );
        echo $this->_oTemplate->parseHtmlByName('123flashchat', $aVars);
        if (getParam('fc_popup') != "on" or (getParam('fc_popup') == "on" and !isset($_GET['room'])))
        {
            $this->_oTemplate->pageCode(_t('_tm_chat'));
        }
    }

    /**
     * Function will generate the chat login return value;
     */
    function actionLogin()
    {
        if (isset($_GET['username']) && isset($_GET['password']))
        {
            $sPassword = $_GET['password'];
            $iId = getID($_GET['username']);
            if (!$iId)
            {
                echo LOGIN_ERROR_NOUSERID;
            }
            else
            {
                $aUser = getProfileInfo($iId);
				//huoqu peizhi wenjian kan shifou xianshi geren xinxi
				$withprofile = (getParam('fc_with_profile')== "on")?1:0;
				$url = "";
				if($withprofile == 1){
					$birth = str_replace("-","",$aUser['DateOfBirth']);
					if(!empty($birth) && $birth > 19010101){
						$url .= "|a=".$birth;
					}
					$url .= $url ? ( ($aUser['Sex'])? ("&s=".(($aUser['Sex']=="female")?2:1)) : "" ) : (($aUser['Sex'])? ("|s=".(($aUser['Sex']=="female")?2:1)) : "") ;
					$url .= $url ? (($aUser['Email'])? ("&eml=".$aUser['Email']) : "") : (($aUser['Email'])? ("|eml=".$aUser['Email']) : "");
					$url .= $url ? (($aUser['City'])? ("&l=".$aUser['City']) : "") : ($aUser['City']? ("|l=".$aUser['City']): "");
				}
				
                if ( ($sPassword == $aUser['Password']) || ($aUser['Password'] == encryptUserPwd($sPassword, $aUser['Salt'])) )
                {
                    if ($aUser['Role'] == ADMIN_ROLE)
                    {
                        echo LOGIN_SUCCESS_ADMIN.$url;
                    }
                    else
                    {
                        echo LOGIN_SUCCESS.$url;
                    }
                }
                else
                {
                    echo LOGIN_PASSWD_ERROR;
                }
            }
        }
        else
        {
            echo LOGIN_ERROR;
        }
    }
/**
    /**
     * Function will generate the chat's settings;
     *
     * @return : (text) - Html presentation data ;
     */
/*
 *  settings no javascript
    function actionSettings()
    {
        if (!$GLOBALS['logged']['admin']) {
            $this->_oTemplate->displayAccessDenied ();
            return;
        }

        // try to define globals category number;
        $iId = $this-> _oDb -> getSettingsCategory('fc_server');
        if(!$iId) {
            $sContent = MsgBox( _t('_Empty') );
        }
        else {
            bx_import('BxDolAdminSettings');

            $mixedResult = '';
            if(isset($_POST['save']) && isset($_POST['cat'])) {
                $oSettings = new BxDolAdminSettings($iId);
                $mixedResult = $oSettings -> saveChanges($_POST);
            }

            $oSettings = new BxDolAdminSettings($iId);
            $sResult = $oSettings->getForm();

            if($mixedResult !== true && !empty($mixedResult))
                $sResult = $mixedResult . $sResult;

            $sCssStyles = $this -> _oTemplate -> addCss( 'forms_adv.css', true );

            $sContent = $sCssStyles . $GLOBALS['oAdmTemplate']
                    -> parseHtmlByName( 'design_box_content.html', array('content' => $sResult) );
        }

        $this -> _oTemplate-> pageStart();
        echo $this -> _oTemplate -> adminBlock ($sContent, _t('_tm_chat_settings'));
        $this -> _oTemplate->pageCodeAdmin ( _t('_tm_chat') );
    }
*/
    function actionSettings()
    {
        if (!$GLOBALS['logged']['admin']) {
            $this->_oTemplate->displayAccessDenied ();
            return;
        }
        if(isset($_POST['save']) && isset($_POST['cat']))
        {
            $mixedResult = "";
            $data['cat'] = $_POST['cat'];
		    $data['fc_server'] = $_POST['server'];
		    switch($_POST['server'])
		    {
                case 0:
	                if ($_POST['server_local'])
	                {
	                    $data['fc_server_host'] = ($_POST['server_host'] != '127.0.0.1') ? $_POST['server_host'] : $_SERVER['HTTP_HOST'];
	                    $data['fc_server_port'] = $_POST['server_port'] ? $_POST['server_port'] : 51127;
	                    $data['fc_http_port'] = $_POST['http_port'] ? $_POST['http_port'] : 35555;
	                    $data['fc_api_url'] = 'http://' . $data['fc_server_host'] . ':' . $data['fc_http_port'] . '/';
	                    $data['fc_client_loc'] = $data['fc_api_url'];
	                    $s_own_loc = $this->validate_server($data['fc_server_host'], $data['fc_server_port']);
	                    $c_own_loc = $this->validate_client($data['fc_client_loc']);
	                    $da = $this->validate_data_api($data['fc_api_url'] . 'online.js');
	                    if ($s_own_loc)
	                    {
	                        $mixedResult .= 'Chat Server host or port is configured incorrectly';
	                    }
	                    if ($da || $c_own_loc)
	                    {
	                        $mixedResult .= 'Chat Server host or http_port is configured incorrectly';
	                    }
                    }
                    else
                    {
                        $data['fc_server_host'] = $_SERVER['HTTP_HOST'];
                        $data['fc_server_port'] = 51127;
	                    $data['fc_http_port'] = 35555;
	                    $data['fc_api_url'] = 'http://' . $data['fc_server_host'] . ':' . $data['fc_http_port'] . '/';
	                    $data['fc_client_loc'] = $data['fc_api_url'];
                    }
	                $data['fc_client'] = $_POST['client'];
	                break;
	            case 1:
	                $data['fc_client_loc'] = $_POST['client_loc'] ? ($_POST['client_loc'] . (substr($_POST['client_loc'],-1,1) != '/' ? '/' : '')) : '';
	                $data['fc_server_host'] = parse_url($data['fc_client_loc'], PHP_URL_HOST);
	                if ($content = @file_get_contents($data['fc_client_loc']))
	                {
	                    preg_match('/init_port=([0-9]*)/', $content, $matches);
	                    $data['fc_server_port'] = $matches[1];
	                }
	                $data['fc_api_url'] = 'http://' . $data['fc_server_host'] . '/';
	                $data['fc_group'] = substr(parse_url($data['fc_client_loc'], PHP_URL_PATH),1,-1);
	                $c_own_loc = $this->validate_client($data['fc_client_loc']);
	                $da = $this->validate_data_api($data['fc_api_url'] . 'online.js?group=' . $data['fc_group']);
	                if ($c_own_loc or $da)
	                {
	                    $mixedResult .= 'Client Location is configured incorrectly';
	                }
	                $data['fc_client'] = $_POST['client'];
	                break;
	            case 2:
	                $data['fc_room'] = $_POST['room'] ? $_POST['room'] : $_SERVER['HTTP_HOST'];
	                $data['fc_client'] = 0;
	                break;
		    }
		    $data['fc_rooms'] = isset($_POST['rooms']) ? "on" : "off";
		    $data['fc_users'] = isset($_POST['users']) ? "on" : "off";
		    $data['fc_popup'] = isset($_POST['popup']) ? "on" : "off";
            $data['fc_client_width'] = ($_POST['client_width'] > 728 ) ? $_POST['client_width'] : 728;
            $data['fc_client_height'] = ($_POST['client_height'] > 500 ) ? $_POST['client_height'] : 500;
	        $data['fc_client_lang'] = isset($_POST['client_lang']) ? $_POST['client_lang'] : "en";
            if (!$data['fc_client'])
            {
                $data['fc_client_skin'] = $_POST['client_skin'];
            }
            if (!$mixedResult)
            {
                $iId = $this-> _oDb -> getSettingsCategory('fc_server');
                bx_import('BxDolAdminSettings');
                $oSettings = new BxDolAdminSettings($iId);
                $mixedResult = $oSettings -> saveChanges($data);
            }
            if(empty($data['fc_group']))
            {
            	$data['fc_group'] == 'default';
            }
			$data['fc_with_profile'] = isset($_POST['with_profile']) ? "on" : "off";
        }
        if (!isset($data))
        {
            $data['fc_server'] = getParam('fc_server');
            $data['fc_server_host'] = getParam('fc_server_host');
            $data['fc_server_port'] = getParam('fc_server_port');
            $data['fc_http_port'] = getParam('fc_http_port');
            $data['fc_room'] = getParam('fc_room');
            $data['fc_rooms'] = getParam('fc_rooms');
            $data['fc_users'] = getParam('fc_users');
            $data['fc_client'] = getParam('fc_client');
            $data['fc_client_loc'] = getParam('fc_client_loc');
            $data['fc_client_width'] = getParam('fc_client_width');
            $data['fc_client_height'] = getParam('fc_client_height');
            $data['fc_popup'] = getParam('fc_popup');
            $data['fc_client_lang'] = getParam('fc_client_lang');
            $data['fc_client_skin'] = getParam('fc_client_skin');
			 $data['fc_with_profile'] = getParam('fc_with_profile');
        }else{

            setParam('fc_server',$data['fc_server']);
            setParam('fc_server_host',$data['fc_server_host']);
            setParam('fc_server_port',$data['fc_server_port']);
            setParam('fc_http_port',$data['fc_http_port']);
            setParam('fc_room',$data['fc_room']);
            setParam('fc_rooms',$data['fc_rooms']);
            setParam('fc_users',$data['fc_users']);
            setParam('fc_client',$data['fc_client']);
            setParam('fc_client_loc',$data['fc_client_loc']);
            setParam('fc_client_width',$data['fc_client_width']);
            setParam('fc_client_height',$data['fc_client_height']);
            setParam('fc_popup',$data['fc_popup']);
            setParam('fc_client_lang',$data['fc_client_lang']);
            setParam('fc_client_skin',$data['fc_client_skin']);
            setParam('fc_api_url',$data['fc_api_url']);
            setParam('fc_group',$data['fc_group']);
			setParam('fc_with_profile',$data['fc_with_profile']);

		}
        $user = getProfileInfo();
        $valid = $this->validate_server('127.0.0.1', '51127') or $this->validate_client("http://127.0.0.1:35555/");
        $aVars = array (
            'check_own' => $data['fc_server'] == "0" ? "checked" : "",
            'check_fc' => $data['fc_server'] == "1" ? "checked" : "",
            'check_free' => $data['fc_server'] == "2" ? "checked" : "",
            'check_standard' => $data['fc_client'] == "0" ? "checked" : "",
            'check_html' => $data['fc_client'] == "1" ? "checked" : "",
            'check_avatar' => $data['fc_client'] == "2" ? "checked" : "",
            'valid' => $valid,
            'dis_own' => (!$valid || ($data['fc_server'] != "0")) ? 'style="display:none"' : '',
			'dis_ownfree' => ($data['fc_server'] == "2") ? 'style="display:none"' : '',
            'server_host' => $data['fc_server_host'],
            'server_port' => $data['fc_server_port'],
            'http_port' => $data['fc_http_port'],
            'dis_fc' => ($data['fc_server'] != "1") ? 'style="display:none"' : '',
            'dis_skin' => ($data['fc_client'] != "0") ? 'style="display:none"' : '',
            'client_loc' => $data['fc_client_loc'],
            'dis_free' => ($data['fc_server'] != "2") ? 'style="display:none"' : '',
            'room' => $data['fc_room'],
            'client_width' => $data['fc_client_width'],
            'client_height' => $data['fc_client_height'],
            'rooms' => $data['fc_rooms'],
            'check_rooms' => $data['fc_rooms'] == "on" ? "checked" : "",
			'dis_rooms' => ($data['fc_server'] != "2") ? '' : 'style="display:none"',
            'users' => $data['fc_users'],
            'check_users' => $data['fc_users'] == "on" ? "checked" : "",
            'popup' => $data['fc_popup'],
            'check_popup' => $data['fc_popup'] == "on" ? "checked" : "",
            'sel_auto' => $data['fc_client_lang'] == "*" ? "selected" : "",
            'sel_en' => $data['fc_client_lang'] == "en" ? "selected" : "",
            'sel_zh-CN' => $data['fc_client_lang'] == "zh-CN" ? "selected" : "",
            'sel_zh-TW' => $data['fc_client_lang'] == "zh-TW" ? "selected" : "",
            'sel_fr' => $data['fc_client_lang'] == "fr" ? "selected" : "",
            'sel_it' => $data['fc_client_lang'] == "it" ? "selected" : "",
            'sel_de' => $data['fc_client_lang'] == "de" ? "selected" : "",
            'sel_nl' => $data['fc_client_lang'] == "nl" ? "selected" : "",
            'sel_hu' => $data['fc_client_lang'] == "hu" ? "selected" : "",
            'sel_es' => $data['fc_client_lang'] == "es" ? "selected" : "",
            'sel_hr' => $data['fc_client_lang'] == "hr" ? "selected" : "",
            'sel_tr' => $data['fc_client_lang'] == "tr" ? "selected" : "",
            'sel_ar' => $data['fc_client_lang'] == "ar" ? "selected" : "",
            'sel_pt' => $data['fc_client_lang'] == "pt" ? "selected" : "",
            'sel_ru' => $data['fc_client_lang'] == "ru" ? "selected" : "",
            'sel_ko' => $data['fc_client_lang'] == "ko" ? "selected" : "",
            'sel_serbian' => $data['fc_client_lang'] == "serbian" ? "selected" : "",
            'sel_no' => $data['fc_client_lang'] == "no" ? "selected" : "",
            'sel_ja' => $data['fc_client_lang'] == "ja" ? "selected" : "",
            'sel_default' => $data['fc_client_skin'] == "default" ? "selected" : "",
            'sel_green' => $data['fc_client_skin'] == "green" ? "selected" : "",
            'sel_orange' => $data['fc_client_skin'] == "orange" ? "selected" : "",
            'sel_red' => $data['fc_client_skin'] == "red" ? "selected" : "",
            'sel_black' => $data['fc_client_skin'] == "black" ? "selected" : "",
            'sel_beige' => $data['fc_client_skin'] == "beige" ? "selected" : "",
            'sel_standard' => $data['fc_client_skin'] == "standard" ? "selected" : "",
            'sel_clean' => $data['fc_client_skin'] == "clean" ? "selected" : "",
            'sel_artistic' => $data['fc_client_skin'] == "artistic" ? "selected" : "",
			'with_profile' => $data['fc_with_profile'],
			'check_with_profile' => $data['fc_with_profile'] == "on" ? "checked" : "",
        );
        $sResult = $this->_oTemplate->parseHtmlByName('settings', $aVars);
        if($mixedResult !== true && !empty($mixedResult))
            $sResult = $mixedResult . $sResult;
        $sCssStyles = $this -> _oTemplate -> addCss( 'forms_adv.css', true );
        $sContent = $sCssStyles . $GLOBALS['oAdmTemplate']
                    -> parseHtmlByName( 'design_box_content.html', array('content' => $sResult) );
        $this -> _oTemplate-> pageStart();
        echo $this -> _oTemplate -> adminBlock ($sContent, _t('_tm_chat_settings'));
        $this -> _oTemplate->pageCodeAdmin ( _t('_tm_chat') );
    }
    /**
	* Check 123 FlashChat Server Config
	* @parm $host   Chat Server Host
	* @parm $port   Chat Server Port
	* @return integer config status
	*/
    function validate_server($host, $port)
    {   $s_own_loc = 1;
        $apiCommand = '<Init/>';
        $resultDoc = "";
        $fp = @fsockopen($host, $port, $errno, $errstr, 2);
        if($fp)
        {
            fputs($fp,$apiCommand."\0");
            while (!feof($fp))
            {
                $resultDoc .= fgets($fp, 1024);
                $resultDoc = rtrim($resultDoc);
            }
            $parser = xml_parser_create("UTF-8");
            xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
            xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
            if (xml_parse_into_struct($parser, $resultDoc, $values, $tags))
            {
                if($values)
                {
                    $s_own_loc = 0;
                }
                xml_parser_free($parser);
                fclose($fp);
            }
        }
        return $s_own_loc;
    }

    /**
	* Check 123 FlashChat Data api
	* @parm $data_api   Chat Data Api
	* @return integer config status
	*/
    function validate_data_api($data_api)
    {   $da = 1;
        if(@file_get_contents($data_api))
        {
        	$da = 0;
    	}
        return $da;
    }

    /**
	* Check 123 FlashChat Client Location
	* @parm $client_loc   Chat Client Location
	* @return integer config status
	*/
    function validate_client($client_loc)
    {
		$c_own_loc = 1;
		$swf = $client_loc . '123flashchat.swf';
        if($headers = @get_headers($client_loc))
        {
            $c_own_loc = (substr($headers[0], 9, 3) == '200') ? 0 : 1;
        }
        return $c_own_loc;
    }
    /**
     * Function will generate the chat's settings;
     *
     * @return : (text) - Html presentation data ;
     */
    function actionAdminPanel()
    {
        if (!$GLOBALS['logged']['admin']) {
            $this->_oTemplate->displayAccessDenied ();
            return;
        }

        $this -> _oTemplate-> pageStart();
        $server = getParam('fc_server');
        $user = getProfileInfo();
        $aVars = array (
            'bx_if:default_chat_admin' => array(
                'condition' => ($server != "2") ? true : false,
                'content' => array(),
            ),
            'bx_if:free_chat_admin' => array(
                'condition' => ($server == "2") ? true : false,
                'content' => array(),
            ),
            'client_loc_admin' => getParam('fc_client_loc') . "123flashchat.js",
            'url' => getParam('fc_client_loc') . "admin_123flashchat.swf?init_host=" . getParam('fc_server_host') . "&init_port=" . getParam('fc_server_port') . "&init_user=" . rawurlencode($user['NickName']) . "&init_password=" . rawurlencode($user['Password']) . (($server == "1") ? ("&init_group=" . getParam('fc_group')) : ""),
        );
        $sContent = $this->_oTemplate->parseHtmlByName('adminpanel', $aVars);
        echo $this -> _oTemplate -> adminBlock ($sContent, _t('_tm_chat_admin_panel'));
        $this -> _oTemplate->pageCodeAdmin ( _t('_tm_chat') );
    }

    /**
     * Function will generate the chat stats;
     */
    function serviceGetChatStats()
    {
        $sOutputCode = '';

        $status = self::getStatus();
        if (getParam('fc_users') == "on")
        {
            $users  = self::getUsers();
        }
        if ((getParam('fc_rooms') == "on") && (getParam('fc_server') != "2"))
        {
            $rooms  = self::getRooms();
        }

        if (isset($status['ln']))
        {
            $sOutputCode .= '<b>' . $status['ln'] . '</b> login users.';
            if (isset($status['rn']))
            {
              $sOutputCode = '<b>' . $status['rn'] . '</b> rooms, ' . '<b>' . $status['cn'] . '</b> connections, ' . $sOutputCode;
            }
        }
        if(isset($rooms))
        {
            $sOutputCode .= "<br /><br /><b>Rooms:</b> ";
            if(!$rooms)
            {
                $sOutputCode .= "None";
            }
            else{
            $xa = '';
            foreach($rooms as $room)
            {
                $js = (getParam('fc_popup') != 'on') ? '' : 'onclick="window.open(this.href,\'123FlashChat\',\'width='. getParam('fc_client_width') . ' ,height=' . getParam('fc_client_height') . '\');return false;"';
                $sOutputCode .= $xa . '<a href="modules/?r=chat/home/&room=' . $room['id'] . '" ' .  $js . ">" .$room['name'] ."</a>(" . $room['count'] . ")";
                $xa = ", ";
            }}
        }
        if(isset($users))
        {
            $sOutputCode .= "<br /><br /><b>Users:</b> ";
            if(!$users)
            {
                $sOutputCode .= "None";
            }
            else{
            $xb = '';
            foreach($users as $user)
            {
                $sOutputCode .= $xb . $user['name'];
                $xb = ', ';
            }}
        }
		$js = (getParam('fc_popup') != 'on') ? '' : 'onclick="window.open(this.href,\'123FlashChat\',\'width='. getParam('fc_client_width') . ' ,height=' . getParam('fc_client_height') . '\');return false;"';
		$sOutputCode .= '<br /><br /><b><a href="modules/?r=chat/home/&room="'.$js.'>Chat Now!</a></b> ';
        $sOutputCode = '<div class="dbContentHtml">' . $sOutputCode . '</div>';
        echo $sOutputCode;
    }

    /**
     * Function will get chat status;
     */
	function getStatus()
	{
        $data = @file_get_contents(BX_DIRECTORY_PATH_CACHE . "status.js");
	    $status_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$status_json)
	    {
	        $server =  getParam('fc_server');
	        switch ($server)
	        {
	            case "0":
	        	    $status_js = getParam('fc_api_url') . "online.js";
	        	    if($rs = @file_get_contents($status_js))
	        	    {
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case "1":
	        	    $status_js = getParam('fc_api_url') . "online.js?group=" . getParam('fc_group');
	        	    if($rs = @file_get_contents($status_js))
	        	    {
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case "2":
	        	    $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . getParam('fc_room');
	        	    if($rs = @file_get_contents($status_js))
	        	    {
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	        	        $status['ln'] = $matches[1];
	        	        $status_json = json_encode($status);
	        	    }
	        	    break;
	        }
			@file_put_contents(BX_DIRECTORY_PATH_CACHE . "status.js",(time() + 300) . $status_json);
	    }
		return json_decode($status_json,true);
	}

    /**
     * Function will get rooms;
     */
	function getRooms()
	{
        $data = @file_get_contents(BX_DIRECTORY_PATH_CACHE ."rooms.js");
		$rooms_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$rooms_json)
	    {
	    	$server =  getParam('fc_server');
	        switch ($server)
	        {
	            case "0":
	        	    $room_js = getParam('fc_api_url') . "rooms.js";
	        	    break;
	            case "1":
	        	    $room_js = getParam('fc_api_url') . "rooms.js?group=" . getParam('fc_group');
	        	    break;
	        }
	        if($rs = @file_get_contents($room_js))
	        {
	        	$rooms_json = substr($rs,10,-1);
	        }
	        @file_put_contents(BX_DIRECTORY_PATH_CACHE ."rooms.js",(time() + 300) . $rooms_json);
	    }
	    return json_decode($rooms_json, true);
	}
    /**
     * Function will get users;
     */
	function getUsers()
	{
		$data =  @file_get_contents(BX_DIRECTORY_PATH_CACHE ."users.js");
		$users_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$users_json)
	    {
	    	$server =  getParam('fc_server');
	        switch ($server)
	        {
	            case "0":
	                $rooms = self::getRooms();
	                $users = array();
	                foreach ($rooms as $room)
	                {
	                    $user_js = getParam('fc_api_url') . "roomonlineusers.js?roomid=" . $room['id'];
	                    if($rs = @file_get_contents($user_js))
	                    {
	                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
	                    }
	                }
	                $users_json = json_encode($users);
	        	    break;
	            case "1":
	        	    $user_js = getParam('fc_api_url') . "roomonlineusers.js?group=" . getParam('fc_group');
	        	    if($rs = @file_get_contents($user_js))
	        	    {
	        	        $users_json = substr($rs,20,-1);
	        	    }
	        	    break;
	        	case "2":
	        	    $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . getParam('fc_room');
	        	    if($rs = @file_get_contents($user_js))
	    	        {
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	    	            foreach (explode(',', $matches[1]) as $user)
	    	            {
	    	                $users[] = array('name' => $user);
	    	            }
	    	        }
	    	        $users_json = json_encode($users);
	    	        break;
	        }
	        @file_put_contents(BX_DIRECTORY_PATH_CACHE ."users.js",(time() + 300) . $users_json);
	    }
	    return json_decode($users_json, true);
	}

}
