
    --
    -- Dumping data for table `sys_page_compose`
    --

    INSERT INTO 
        `sys_page_compose` 
    (`Page`, `PageWidth`, `Desc`, `Caption`, `Column`, `Order`, `Func`, `Content`, `DesignBox`, `ColWidth`, `Visible`, `MinWidth`)
        VALUES
    ('index', '998px', 'Display chat stats with rooms and users list', '_tm_chat_stats', 2, 0, 'PHP', 'BxDolService::call(''chat'', ''get_chat_stats'');', 1, 34, 'non,memb', 0);

    --
    -- Dumping data for table `sys_acl_actions`
    --

    SET @iLevelNonMember := 1;
    SET @iLevelStandard  := 2;
    SET @iLevelPromotion := 3;

    INSERT INTO `sys_acl_actions` VALUES (NULL, 'use fchat', NULL);
    SET @iAction := LAST_INSERT_ID();

    INSERT INTO `sys_acl_matrix` (`IDLevel`, `IDAction`) VALUES 
        (@iLevelNonMember, @iAction), 
        (@iLevelStandard, @iAction), 
        (@iLevelPromotion, @iAction);
    
    --
    -- Top menu ;
    --

    INSERT INTO 
        `sys_menu_top` 
    SET
        `Parent`        = 0,
        `Name`          = '123FlashChat',
        `Caption`       = '_tm_chat', 
        `Link`          = 'modules/?r=chat/home/',
        `Order`         = 4,
        `Visible`       = 'non,memb',
        `Target`        = '',
        `Onclick`       = '',
        `Check`         = '',
        `Icon`          = 'modules/topcmm/chat/|123flashchat.gif';
    
    --
    -- Admin menu ;
    --

    INSERT INTO 
        `sys_menu_admin` 
    SET
        `name`          = '123FlashChat',
        `title`         = '_tm_chat_settings', 
        `url`           = '{siteUrl}modules/?r=chat/settings/',
        `description`   = 'Some chat''s settings',
        `icon`          = 'modules/topcmm/chat/|123flashchat.gif',
        `parent_id`     = 2;
    
    INSERT INTO 
        `sys_menu_admin` 
    SET
        `name`          = '123FlashChat',
        `title`         = '_tm_chat_admin_panel', 
        `url`           = '{siteUrl}modules/?r=chat/adminpanel/',
        `description`   = 'Chat''s admin panel',
        `icon`          = 'modules/topcmm/chat/|123flashchat.gif',
        `parent_id`     = 2;
    
    --
    -- `sys_options_cats` ;
    --

    SET @iMaxOrder = (SELECT `menu_order` + 1 FROM `sys_options_cats` ORDER BY `menu_order` DESC LIMIT 1);
    INSERT INTO `sys_options_cats` (`name`, `menu_order`) VALUES ('123FlashChat', @iMaxOrder);
    SET @iKategId = (SELECT LAST_INSERT_ID());

    --
    -- Dumping data for table `sys_options`;
    --

    INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_server',
        `kateg` = @iKategId,
        `desc`  = 'Chat server mode',
        `Type`  = 'select',
        `AvailableValues` = 'PHP:return array( array("key"=> 0, "value"=>_t("_tm_chat_server_own")), array("key"=> 1, "value"=>_t("_tm_chat_server_host")),array("key"=> 2, "value"=>_t("_tm_chat_server_free")) );',
        `VALUE` = 2,
        `order_in_kateg` = 1;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_server_host',
        `kateg` = @iKategId,
        `desc`  = 'Chat Server Host',
        `Type`  = 'digit',
        `VALUE` = '',
        `check` = '',
        `order_in_kateg` = 2;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_server_port',
        `kateg` = @iKategId,
        `desc`  = 'Chat Server Port',
        `Type`  = 'digit',
        `VALUE` = '51127',
        `check` = 'return is_numeric($arg0);',
        `order_in_kateg` = 3;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_http_port',
        `kateg` = @iKategId,
        `desc`  = 'Chat Http Port',
        `Type`  = 'digit',
        `VALUE` = '35555',
        `check` = 'return is_numeric($arg0);',
        `order_in_kateg` = 4;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_client_loc',
        `kateg` = @iKategId,
        `desc`  = 'Chat Client Location',
        `Type`  = 'digit',
        `VALUE` = '',
        `check` = '',
        `order_in_kateg` = 5;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_api_url',
        `kateg` = @iKategId,
        `desc`  = 'Chat API URL',
        `Type`  = 'digit',
        `VALUE` = '',
        `check` = '',
        `order_in_kateg` = 6;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_group',
        `kateg` = @iKategId,
        `desc`  = 'Chat Group',
        `Type`  = 'digit',
        `VALUE` = 'default',
        `check` = '',
        `order_in_kateg` = 7;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_room',
        `kateg` = @iKategId,
        `desc`  = 'Chat room name',
        `Type`  = 'digit',
        `VALUE` = 'Lobby',
        `check` = '',
        `order_in_kateg` = 8;
        
    INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_rooms',
        `kateg` = @iKategId,
        `desc`  = 'Show rooms list',
        `Type`  = 'checkbox',
        `VALUE` = 'on',
        `order_in_kateg` = 10;
        
    INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_users',
        `kateg` = @iKategId,
        `desc`  = 'Show users list',
        `Type`  = 'checkbox',
        `VALUE` = 'on',
        `order_in_kateg` = 11;
        
    INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_client',
        `kateg` = @iKategId,
        `desc`  = 'Chat client mode',
        `Type`  = 'select',
        `AvailableValues` = 'PHP:return array( array("key"=> 0, "value"=>_t("_tm_chat_client_standard")), array("key"=> 1, "value"=>_t("_tm_chat_client_html")),array("key"=> 2, "value"=>_t("_tm_chat_client_avatar")) );',
        `VALUE` = 0,
        `order_in_kateg` = 12;

    INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_popup',
        `kateg` = @iKategId,
        `desc`  = 'Show chat in popup mode',
        `Type`  = 'checkbox',
        `VALUE` = 'on',
        `order_in_kateg` = 13;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_client_width',
        `kateg` = @iKategId,
        `desc`  = 'Chat Client Width',
        `Type`  = 'digit',
        `VALUE` = '779',
        `check` = 'return is_numeric($arg0);',
        `order_in_kateg` = 14;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_client_height',
        `kateg` = @iKategId,
        `desc`  = 'Chat Client Height',
        `Type`  = 'digit',
        `VALUE` = '580',
        `check` = 'return is_numeric($arg0);',
        `order_in_kateg` = 15;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_client_lang',
        `kateg` = @iKategId,
        `desc`  = 'Chat Client Language',
        `Type`  = 'select',
        `AvailableValues` = 'PHP:return array( array("key"=> "*", "value"=>_t("_tm_chat_lang_auto")), array("key"=>"en", "value"=>_t("_tm_chat_lang_en")), array("key"=>"zh-CN", "value"=>_t("_tm_chat_lang_sc")), array("key"=>"zh-TW", "value"=>_t("_tm_chat_lang_tc")), array("key"=>"fr", "value"=>_t("_tm_chat_lang_fr")), array("key"=>"it", "value"=>_t("_tm_chat_lang_it")), array("key"=>"de", "value"=>_t("_tm_chat_lang_de")), array("key"=>"nl", "value"=>_t("_tm_chat_lang_nl")), array("key"=>"hu", "value"=>_t("_tm_chat_lang_hu")), array("key"=>"es", "value"=>_t("_tm_chat_lang_es")), array("key"=>"hr", "value"=>_t("_tm_chat_lang_hr")), array("key"=>"tr", "value"=>_t("_tm_chat_lang_tr")), array("key"=>"ar", "value"=>_t("_tm_chat_lang_ar")), array("key"=>"pt", "value"=>_t("_tm_chat_lang_pt")), array("key"=>"ru", "value"=>_t("_tm_chat_lang_ru")), array("key"=>"ko", "value"=>_t("_tm_chat_lang_ko")), array("key"=>"serbian", "value"=>_t("_tm_chat_lang_serbian")), array("key"=>"no", "value"=>_t("_tm_chat_lang_no")), array("key"=>"ja", "value"=>_t("_tm_chat_lang_ja")), );',
        `VALUE` = 'en',
        `check` = '',
        `order_in_kateg` = 16;

   INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_client_skin',
        `kateg` = @iKategId,
        `desc`  = 'Chat client skin',
        `Type`  = 'select',
        `AvailableValues` = 'PHP:return array( array("key"=>"default", "value"=>_t("_tm_chat_skin_blue")), array("key"=>"green", "value"=>_t("_tm_chat_skin_green")), array("key"=>"orange", "value"=>_t("_tm_chat_skin_orange")), array("key"=>"red", "value"=>_t("_tm_chat_skin_red")), array("key"=>"black", "value"=>_t("_tm_chat_skin_black")), array("key"=>"beige", "value"=>_t("_tm_chat_skin_beige")), array("key"=>"standard", "value"=>_t("_tm_chat_skin_standard")), array("key"=>"clean", "value"=>_t("_tm_chat_skin_clean")), array("key"=>"artistic", "value"=>_t("_tm_chat_skin_artistic")), );',
        `VALUE` = 'default',
        `check` = '',
        `order_in_kateg` = 17;
		
	INSERT INTO 
        `sys_options` 
    SET
        `Name` = 'fc_with_profile',
        `kateg` = @iKategId,
        `desc`  = 'Show user profile in flashchat',
        `Type`  = 'checkbox',
        `VALUE` = 'on',
        `order_in_kateg` = 18;
        

